/*
*  Copyright 2019-2020 Zheng Jie
*
*  Licensed under the Apache License, Version 2.0 (the "License");
*  you may not use this file except in compliance with the License.
*  You may obtain a copy of the License at
*
*  http://www.apache.org/licenses/LICENSE-2.0
*
*  Unless required by applicable law or agreed to in writing, software
*  distributed under the License is distributed on an "AS IS" BASIS,
*  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
*  See the License for the specific language governing permissions and
*  limitations under the License.
*/
package com.youchain.businessdata.service;

import com.youchain.basicdata.domain.Area;
import com.youchain.basicdata.domain.Item;
import com.youchain.basicdata.domain.Point;
import com.youchain.basicdata.domain.Stock;
import com.youchain.businessdata.domain.Inventory;
import com.youchain.businessdata.domain.ItemKey;
import com.youchain.businessdata.inputJson.buttenJson.InvYW;
import com.youchain.businessdata.inputJson.buttenJson.InventoryButton;
import com.youchain.businessdata.returnJson.RInvQuery;
import com.youchain.businessdata.returnJson.XdInventory;
import com.youchain.businessdata.service.dto.InvQueryCriteria;
import com.youchain.businessdata.service.dto.InventoryDto;
import com.youchain.businessdata.service.dto.InventoryQueryCriteria;
import com.youchain.businessdata.service.dto.InventoryQueryDto;
import com.youchain.modules.system.domain.Dept;
import org.springframework.data.domain.Pageable;
import java.util.Map;
import java.util.List;
import java.io.IOException;
import javax.servlet.http.HttpServletResponse;

/**
* @website https://eladmin.vip
* @description 服务接口
* @author huojin
* @date 2023-08-22
**/
public interface InventoryService {

    /**
    * 查询数据分页
    * @param criteria 条件
    * @param pageable 分页参数
    * @return Map<String,Object>
    */
    Map<String,Object> queryAll(InventoryQueryCriteria criteria, Pageable pageable);


    /**
    * 查询所有数据不分页
    * @param criteria 条件参数
    * @return List<InventoryDto>
    */
    List<InventoryDto> queryAll(InventoryQueryCriteria criteria);

    List<InventoryDto> queryAll(InvQueryCriteria criteria);
    Map<String,Object> queryInvAll(InventoryQueryCriteria criteria, Pageable pageable);
    List<InventoryQueryDto>  queryInvAll(InventoryQueryCriteria criteria);

    /**
     * 根据ID查询
     * @param id ID
     * @return InventoryDto
     */
    InventoryDto findById(Long id);

    /**
    * 创建
    * @param resources /
    * @return InventoryDto
    */
    InventoryDto create(Inventory resources);

    /**
    * 编辑
    * @param resources /
    */
    void update(Inventory resources);

    /**
    * 多选删除
    * @param ids /
    */
    void deleteAll(Long[] ids);

    /**
    * 导出数据
    * @param all 待导出的数据
    * @param response /
    * @throws Exception /
    */
    void download(List<InventoryDto> all, HttpServletResponse response) throws Exception, Exception;

    void downloadXb(List<InventoryDto> all, HttpServletResponse response) throws Exception, Exception;


    void downloadXt(List<InventoryDto> all, HttpServletResponse response) throws Exception, Exception;


    void downloadZz(List<InventoryQueryDto> all, HttpServletResponse response) throws Exception, Exception;

    List<Inventory> queryInventoryAllocate(long itemId,long areaId,Long zzkwId,Long pointId,String stockCode,String propC2,String type);

    /**
     * 得到线边库存数量
     * @param itemId
     * @param areaId
     * @param zzkwId
     * @return
     */
    Double getInvQty(long itemId, long areaId,Long zzkwId);

    List<Inventory> queryInventory(Long areaId,Long pointId,Long itemKeyId);

    Inventory getInventory(ItemKey itemKey, Area area, Point point,Point zzkw, Dept dept, String type,String stockCode);

    /**
     * 满足线边耗用库存
     * @param item
     * @param area
     * @param zzkw
     * @param type
     * @return
     */
    List<Inventory> getXbHyInv(Item item, Area area,Point zzkw,String type,String big_item_code);
    List<Inventory> getInventoryXbTl(Item item, Area area, Point point,Point zzkw);
    List<Inventory> queryInventory(Stock stock);

    List<Inventory> getInvForPlan(String type,Long areaId,Long itemId,Long deptId);


    void kuneMovePosition(InvYW invYW);

    /**
     * 查询库存
     * @return
     */
    List<RInvQuery> queryInvApp(String code,String pointCode);

    List<XdInventory> queryInvForPickDetail(Long pickDetailId);
}
